<?php
# wget
/***
 * 2015-09-23 npwg_split(): fixed skip 100
 */

  if(!defined('CR')) define('CR', "\r");
  if(!defined('LF')) define('LF', "\n");
  if(!defined('CRLF')) define('CRLF', CR.LF);

  function npwg_hdr_skip($resp, $p1) {
    $skips = array(
		   'HTTP/1.1 100 Continue',
		   'HTTP/1.0 200 Connection established',
		   'HTTP/1.1 200 Connection established',
		   );
    foreach($skips as $skip)
      if(strpos($resp, $skip, $p1) === $p1)
	return true;
    return false;
  }

  function npwg_split($resp) {
    // split http-header and -contents (honouring HTTP 100 replies)
    $p1 = 0;
    while(npwg_hdr_skip($resp, $p1))
      $p1 = 4 + strpos($resp, CRLF.CRLF, $p1);
    $p1 = strpos($resp, CRLF.CRLF, $p1);
    $hdr = substr($resp, 0, $p1+2);
    $cnt = substr($resp, $p1+4);
    return array($hdr, $cnt);
  }

  function npwg_get($url, $copt=null, $post = NULL, $cookies = null, $body=TRUE) {

    if(strpos($url, '://') === false) $url = "http://$url";
    echo empty($post) ? $body ? 'GET' : 'HEAD' : 'POST';
    echo " $url" .LF;

    $ch = curl_init();
    
    $header[] = "Accept-Encoding: gzip,deflate";
#    curl_setopt($ch, CURLOPT_HTTPHEADER, $header );
    curl_setopt($ch, CURLOPT_ENCODING , "gzip,deflate");
  
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_HEADER, true);	// 1 = true
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_NOBODY, !$body);
    //curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    //curl_setopt($ch, CURLOPT_AUTORFERER, true);
    //curl_setopt($ch, CURLOPT_MAXREDIRS, 2);
    //curl_setopt($ch, CURLOPT_COOKIEFILE, '');
    //curl_setopt($ch, CURLOPT_COOKIEJAR, '');
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5); // default is 0 (for never)
    //curl_setopt($ch, CURLOPT_TIMEOUT, 30);	// default is 0 (for never)


    if(!empty($cookies)) curl_setopt($ch, CURLOPT_COOKIE, $cookies);

    if(!empty($copt) && is_array($copt))
      foreach($copt as $k => $v)
	curl_setopt($ch, $k , $v);
    if(!empty($post)) curl_setopt($ch, CURLOPT_POSTFIELDS, $post);

    $resp = curl_exec($ch);	// grab Response as string
    curl_close($ch);		// close cURL resource, and free up system resources

    return $resp;
  }
  function npwg_post($url, $copt, $post, $cookie=null) {
    return npwg_get($url, $copt, $post, $cookie);
  }
  function npwg_head($url, $copt=null, $post = NULL, $cookie = null) {
    return npwg_get($url, $copt, $post, $cookie, FALSE);
  }
  function npwg_info($url, $copt=null, $post = NULL, $cookie = null) {
    $http = npwg_get($url, $copt, $post, $cookie);
    return substr($http, 0, strpos($http, CRLF));
  }

  function npwg_showget($url, $copt=null, $post = NULL, $cookie = null, $body=TRUE) {
    $t0 = microtime(true);
    $resp = npwg_get($url, $copt, $post, $cookie, $body);
    $t1 = microtime(true);
    list($hdr, $cnt) = npwg_split($resp);
    printf("-- time: %6.3f\n", $t1 - $t0);
    echo $hdr ."================".CRLF;
    if(isset($_SERVER["HTTP_HOST"]))
      echo str_replace('<', '&lt;', $cnt);
    else
      echo $cnt;
    return array($hdr, $cnt);
  }

  function npwg_showhead($url, $copt=null, $post = NULL, $cookie = null, $body=FALSE) {
    $t0 = microtime(true);
    $resp = npwg_get($url, $copt, $post, $cookie, $body);
    $t1 = microtime(true);
    list($hdr, $cnt) = npwg_split($resp);
    printf("-- time: %6.3f\n", $t1 - $t0);
    echo $hdr;
    if($body)
      echo "Length=".strlen($cnt);
    echo CRLF."================".CRLF;
    return array($hdr, $cnt);
  }

  function npwg_parse_hdr($hdr, $offset = 0) {
    $head = new stdclass;
    foreach(explode(CRLF, $hdr) as $line) {
      if(!$line) continue;
      if(strpos($line, ': ') === false) {
	list($head->prot, $head->stat, $head->smsg) = explode(' ', $line);
      } else {
	list($k, $v) = explode(': ', $line);
	$head->$k = $v;
      }
    }
    return $head;
  }

  function npwg_get_cookie($hdr) {
    $cookie = '';
    $cc = 'Set-Cookie: ';
    $p1 = strpos($hdr, $cc); if($p1 === false) return $p1;
    while($p1) {
      $p1 += strlen($cc);
      $l = strcspn($hdr, " ;\r\n", $p1);
      $cookie = substr($hdr, $p1, $l);
      $p1 = strpos($hdr, $cc, $p1);
    }
    return $cookie;
  }

  function npwg_delay($t = 5) {
    echo "delay($t) ...".LF;
    sleep($t);
  }